OGRE: Ogre::Overlay Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Overlay Class Reference
Optional Components » Overlay

Represents a layer which is rendered on top of the 'normal' scene contents. More...

`#include <OgreOverlay.h>`

Inheritance diagram for Ogre::Overlay:
[legend]

## Public Types
typedef std::list< OverlayContainer * > | OverlayContainerList

## Public Member Functions
| Overlay (const String &name)
| Constructor: do not call direct, use OverlayManager::create.
virtual | ~Overlay ()
virtual void | _findVisibleObjects (Camera *cam, RenderQueue *queue, Viewport *vp)
| Internal method to put the overlay contents onto the render queue.
void | _getWorldTransforms (Matrix4 *xform) const
| Used to transform the overlay when scrolling, scaling etc.
void | _notifyOrigin (const String &origin)
| Notify this overlay of it's origin.
void | add2D (OverlayContainer *cont)
| Adds a 2D 'container' to the overlay.
void | add3D (SceneNode *node)
| Adds a node capable of holding 3D objects to the overlay.
void | clear ()
| Clears the overlay of all attached items.
virtual OverlayElement * | findElementAt (Real x, Real y)
| This returns a OverlayElement at position x,y.
const OverlayContainerList & | get2DElements () const
| Returns all 2D elements in this manager.
OverlayContainer * | getChild (const String &name)
const String & | getName (void) const
| Gets the name of this overlay.
const String & | getOrigin (void) const
| Get the origin of this overlay, e.g.
const Radian & | getRotate (void) const
| Gets the rotation applied to this overlay, in degrees.
Real | getScaleX (void) const
| Gets the current X scale value.
Real | getScaleY (void) const
| Gets the current Y scale value.
Real | getScrollX (void) const
| Gets the current X scroll value.
Real | getScrollY (void) const
| Gets the current Y scroll value.
ushort | getZOrder (void) const
| Gets the Z-order of this overlay.
void | hide (void)
| Hides the overlay if it was visible.
bool | isInitialised (void) const
| Gets whether the overlay is initialised or not.
bool | isVisible (void) const
| Gets whether the overlay is displayed or not.
void | remove2D (OverlayContainer *cont)
| Removes a 2D container from the overlay.
void | remove3D (SceneNode *node)
| Removes a 3D element from the overlay.
void | rotate (const Radian &angle)
| Adds the passed in angle to the rotation applied to this overlay.
void | scroll (Real xoff, Real yoff)
| Scrolls the overlay by the offsets provided.
void | setRotate (const Radian &angle)
| Sets the rotation applied to this overlay.
void | setScale (Real x, Real y)
| Sets the scaling factor of this overlay.
void | setScroll (Real x, Real y)
| Sets the scrolling factor of this overlay.
void | setVisible (bool visible)
| Shows or hides this overlay.
void | setZOrder (ushort zorder)
| Alters the Z-order of this overlay.
void | show (void)
| Shows the overlay if it was hidden.

## Detailed Description

Represents a layer which is rendered on top of the 'normal' scene contents.

An overlay is a container for visual components (2D and 3D) which will be rendered after the main scene in order to composite heads-up-displays, menus or other layers on top of the contents of the scene.

  An overlay always takes up the entire size of the viewport, although the components attached to it do not have to. An overlay has no visual element in itself, it it merely a container for visual elements.

  Overlays are created by calling OverlayManager::create, or by defining them in special text scripts (.overlay files). As many overlays as you like can be defined; after creation an overlay is hidden i.e. not visible until you specifically enable it by calling 'show'. This allows you to have multiple overlays predefined (menus etc) which you make visible only when you want. It is possible to have multiple overlays enabled at once; in this case the relative 'zorder' parameter of the overlays determine which one is displayed on top.

  By default overlays are rendered into all viewports. This is fine when you only have fullscreen viewports, but if you have picture-in-picture views, you probably don't want the overlay displayed in the smaller viewports. You turn this off for a specific viewport by calling the Viewport::setDisplayOverlays method.

## Member Typedef Documentation

## ◆ OverlayContainerList

typedef std::list<OverlayContainer*> Ogre::Overlay::OverlayContainerList

## Constructor & Destructor Documentation

## ◆ Overlay()

Ogre::Overlay::Overlay | ( | const String & | name | ) |

Constructor: do not call direct, use OverlayManager::create.

## ◆ ~Overlay()

virtual Ogre::Overlay::~Overlay | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ getChild()

OverlayContainer * Ogre::Overlay::getChild | ( | const String & | name | ) |

## ◆ getName()

const String & Ogre::Overlay::getName | ( | void |  | ) | const

Gets the name of this overlay.

## ◆ setZOrder()

void Ogre::Overlay::setZOrder | ( | ushort | zorder | ) |

Alters the Z-order of this overlay.

Values between 0 and 650 are valid here.

## ◆ getZOrder()

ushort Ogre::Overlay::getZOrder | ( | void |  | ) | const

Gets the Z-order of this overlay.

## ◆ isVisible()

bool Ogre::Overlay::isVisible | ( | void |  | ) | const

Gets whether the overlay is displayed or not.

## ◆ isInitialised()

bool Ogre::Overlay::isInitialised | ( | void |  | ) | const
| inline

Gets whether the overlay is initialised or not.

## ◆ show()

void Ogre::Overlay::show | ( | void |  | ) |

Shows the overlay if it was hidden.

## ◆ hide()

void Ogre::Overlay::hide | ( | void |  | ) |

Hides the overlay if it was visible.

## ◆ setVisible()

void Ogre::Overlay::setVisible | ( | bool | visible | ) |

Shows or hides this overlay.

## ◆ add2D()

void Ogre::Overlay::add2D | ( | OverlayContainer * | cont | ) |

Adds a 2D 'container' to the overlay.

Containers are created and managed using the OverlayManager. A container could be as simple as a square panel, or something more complex like a grid or tree view. Containers group collections of other elements, giving them a relative coordinate space and a common z-order. If you want to attach a GUI widget to an overlay, you have to do it via a container.

Parameters

  cont | Pointer to a container to add, created using OverlayManager.

## ◆ remove2D()

void Ogre::Overlay::remove2D | ( | OverlayContainer * | cont | ) |

Removes a 2D container from the overlay.

NOT FAST. Consider OverlayElement::hide.

## ◆ add3D()

void Ogre::Overlay::add3D | ( | SceneNode * | node | ) |

Adds a node capable of holding 3D objects to the overlay.

Although overlays are traditionally associated with 2D elements, there are reasons why you might want to attach 3D elements to the overlay too. For example, if you wanted to have a 3D cockpit, which was overlaid with a HUD, then you would create 2 overlays, one with a 3D object attached for the cockpit, and one with the HUD elements attached (the zorder of the HUD overlay would be higher than the cockpit to ensure it was always on top).

A SceneNode can have any number of 3D objects attached to it. SceneNodes are usually created using SceneManager::createSceneNode, but in this case you should create a standard SceneNode instance manually; this is because these scene nodes are not managed by the SceneManager and some custom SceneManager plugins will rely on specialist behaviour the overlay does not support. By attaching a SceneNode to an overlay, you indicate that:

1. You want the contents of this node to only appear when the overlay is active
2. You want the node to inherit a coordinate space relative to the camera, rather than relative to the root scene node
3. You want these objects to be rendered after the contents of the main scene to ensure they are rendered on top

One major consideration when using 3D objects in overlays is the behaviour of the depth buffer. Overlays should use materials with depth checking off, to ensure that their contents are always displayed on top of the main scene (to do otherwise would result in objects 'poking through' the overlay). The problem with using 3D objects is that if they are concave, or self-overlap, then you can get artefacts because of the lack of depth buffer checking. So you should ensure that any 3D objects you us in the overlay are convex, and don't overlap each other. If they must overlap, split them up and put them in 2 overlays. Alternatively, use a 2D element underneath them which will clear the depth buffer values underneath ready for the 3D element to be rendered correctly.

## ◆ remove3D()

void Ogre::Overlay::remove3D | ( | SceneNode * | node | ) |

Removes a 3D element from the overlay.

## ◆ clear()

void Ogre::Overlay::clear | ( |  | ) |

Clears the overlay of all attached items.

## ◆ setScroll()

void Ogre::Overlay::setScroll | ( | Real | x,
|  | Real | y )

Sets the scrolling factor of this overlay.

You can use this to set an offset to be used to scroll an overlay around the screen.

Parameters

  x | Horizontal scroll value, where 0 = normal, -0.5 = scroll so that only the right half the screen is visible etc
  y | Vertical scroll value, where 0 = normal, 0.5 = scroll down by half a screen etc.

## ◆ getScrollX()

Real Ogre::Overlay::getScrollX | ( | void |  | ) | const

Gets the current X scroll value.

## ◆ getScrollY()

Real Ogre::Overlay::getScrollY | ( | void |  | ) | const

Gets the current Y scroll value.

## ◆ scroll()

void Ogre::Overlay::scroll | ( | Real | xoff,
|  | Real | yoff )

Scrolls the overlay by the offsets provided.

This method moves the overlay by the amounts provided. As with other methods on this object, a full screen width / height is represented by the value 1.0.

## ◆ setRotate()

void Ogre::Overlay::setRotate | ( | const Radian & | angle | ) |

Sets the rotation applied to this overlay.

## ◆ getRotate()

const Radian & Ogre::Overlay::getRotate | ( | void |  | ) | const
| inline

Gets the rotation applied to this overlay, in degrees.

## ◆ rotate()

void Ogre::Overlay::rotate | ( | const Radian & | angle | ) |

Adds the passed in angle to the rotation applied to this overlay.

## ◆ setScale()

void Ogre::Overlay::setScale | ( | Real | x,
|  | Real | y )

Sets the scaling factor of this overlay.

You can use this to set an scale factor to be used to zoom an overlay.

Parameters

  x | Horizontal scale value, where 1.0 = normal, 0.5 = half size etc
  y | Vertical scale value, where 1.0 = normal, 0.5 = half size etc

## ◆ getScaleX()

Real Ogre::Overlay::getScaleX | ( | void |  | ) | const

Gets the current X scale value.

## ◆ getScaleY()

Real Ogre::Overlay::getScaleY | ( | void |  | ) | const

Gets the current Y scale value.

## ◆ _getWorldTransforms()

void Ogre::Overlay::_getWorldTransforms | ( | Matrix4 * | xform | ) | const

Used to transform the overlay when scrolling, scaling etc.

## ◆ _findVisibleObjects()

virtual void Ogre::Overlay::_findVisibleObjects | ( | Camera * | cam,
|  | RenderQueue * | queue,
|  | Viewport * | vp )
| virtual

Internal method to put the overlay contents onto the render queue.

Reimplemented in Ogre::ImGuiOverlay.

## ◆ findElementAt()

virtual OverlayElement * Ogre::Overlay::findElementAt | ( | Real | x,
|  | Real | y )
| virtual

This returns a OverlayElement at position x,y.

## ◆ get2DElements()

const OverlayContainerList & Ogre::Overlay::get2DElements | ( |  | ) | const
| inline

Returns all 2D elements in this manager.

## ◆ getOrigin()

const String & Ogre::Overlay::getOrigin | ( | void |  | ) | const
| inline

Get the origin of this overlay, e.g.

a script file name.

This property will only contain something if the creator of this overlay chose to populate it. Script loaders are advised to populate it.

## ◆ _notifyOrigin()

void Ogre::Overlay::_notifyOrigin | ( | const String & | origin | ) |
| inline

Notify this overlay of it's origin.

The documentation for this class was generated from the following file:

- OgreOverlay.h